//
//  MainView.m
//  MemoryTraining
//
//  Created by Jiayao Yu on 3/27/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "GameView.h"
#import "GameViewController.h"
#import "FlipPanel.h"
#import "Level.h"

@implementation GameView
@synthesize level;
@synthesize panels;
@synthesize controller;
@synthesize statusLabel;

- (id)initWithFrame:(CGRect)frame {
    if (self = [super initWithFrame:frame]) {
    }
    return self;
}

- (void)clear {
  int count = [[self panels] count];
  for (int i = 0 ; i< count; i++) {
    FlipPanel *panel = [panels lastObject];
    [panel removeFromSuperview];
    [panels removeLastObject];
    [panel release];
  }
}

- (void)refresh {
  [self clear];
  for (int i =0; i < [level size]; i++) {
    for (int j = 0; j < [level size]; j++) {
      FlipPanel *view = [[FlipPanel alloc] initWithFrame:[level tileRect:j row:i]];
      [view setBackgroundColor:[UIColor whiteColor]];
      [self.panels addObject:view];
      [self addSubview:view];
    }
  }
  [self flashPattern];
}

- (void)setFlipPanelsEnabled:(BOOL)value {
  int count = [[self panels] count];
  for (int i = 0 ; i< count; i++) {
    FlipPanel *panel  = [panels objectAtIndex:i];
    [panel setUserInteractionEnabled:value];
  }
}

- (void)awakeFromNib
{
  self.panels = [[NSMutableArray arrayWithCapacity:9] retain];
}

- (void)resetPanels {
  for (int i =0; i < [level area]; i++) {
    FlipPanel *panel = [[self panels] objectAtIndex:i];
    if ([[[level pattern] objectAtIndex:i] boolValue] &&
      ![panel flipped]) {
      [panel changeColorAnimation:[UIColor whiteColor] transition:UIViewAnimationTransitionFlipFromRight];
    }
  }
}

- (void)showPattern {
  for (int i =0; i < [level area]; i++) {
    if ([[[level pattern] objectAtIndex:i] boolValue] &&
        ![[panels objectAtIndex:i] flipped]) {
      [[panels objectAtIndex:i] changeColorAnimation:[UIColor redColor] transition:UIViewAnimationTransitionFlipFromLeft];
    } 
  }
}


- (void)flashPattern {
  [self showPattern];
  [NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector (resetPanels) userInfo:nil repeats:NO];
}

- (void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event {  
  [controller touched];
}

- (void)drawRect:(CGRect)rect {
  [super drawRect:rect];
}

- (void)dealloc {
    [super dealloc];
  [panels release];
}

@end
