//
//  Level.m
//  MemoryTraining
//
//  Created by Jiayao Yu on 3/28/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "Level.h"
#include <stdlib.h>
#include <time.h>

@implementation Level
@synthesize level;
@synthesize pattern;


-(int) numFlippers {
  return level % 3 + 2 + level / 3;
}

-(id) initWithLevel:(int)aLevel {
  NSLog(@"pattern retain count %d", [pattern retainCount]);
  [pattern release];
  level = aLevel;
  int capacity = [self size] * [self size];
  self.pattern = [[NSMutableArray arrayWithCapacity:capacity] retain];
  for (int i = 0; i < capacity; i++) {
    [pattern addObject:[NSNumber numberWithBool:NO]];
  }
  srand ( time(NULL) );
  for (int i = 0; i < [self numFlippers]; i++) {
    int flip = rand() % capacity;
    if ([pattern objectAtIndex:flip] != [NSNumber numberWithBool:YES]) {
      [pattern replaceObjectAtIndex:flip withObject:[NSNumber numberWithBool:YES]];
    } else {
      i--;
    }
  }
  return self;
}

-(int) size {
  return level / 3 + 3;
}

-(int) area {
  return [self size] * [self size];
}


-(void) reset {
  [self initWithLevel:level];
}

-(void) advance {
  [self initWithLevel:++level];
}

- (CGRect)tileRect:(int)col row:(int)row {
  int unitSize = 290 / [self size] - 5;
  return CGRectMake(20 + (unitSize + 5) * col, 100 + (unitSize + 5) * row, unitSize, unitSize);
 // if (level == 1)
//    return CGRectMake(75 + 65 * col, 115 + 45 * row, 60, 40);

    
}

-(void) dealloc {
  [super dealloc];
  [pattern release];
}


@end
