//
//  MainViewController.m
//  MemoryTraining
//
//  Created by Jiayao Yu on 3/28/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "MainViewController.h"
#import "GameViewController.h"
#import "CustomGameViewController.h"
#import "StatsViewController.h"
#import "MemoryTrainingAppDelegate.h"

@implementation MainViewController
@synthesize coreDataHelper;
/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
  [super viewDidLoad];
  gameViewController = [[GameViewController alloc] initWithNibName:@"MemoryTrainingViewController" bundle:nil];
  statsViewController = [[StatsViewController alloc] initWithNibName:@"StatsViewController" bundle:nil];
  customGameViewController = [[CustomGameViewController alloc] initWithNibName:@"CustomGameViewController" bundle:nil];
  gameViewController.coreDataHelper = self.coreDataHelper;
  statsViewController.coreDataHelper = self.coreDataHelper;
  customGameViewController.gameViewController = gameViewController;
}


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (IBAction)quickPlay {
  [self presentModalViewController:gameViewController animated:NO];
  [gameViewController restart];
}

-(IBAction)showStats {
  [self presentModalViewController:statsViewController animated:YES];
}
-(IBAction)customGame {
  [self presentModalViewController:customGameViewController animated:YES];
}

- (void)dealloc {
  [super dealloc];
  [gameViewController release];
  [statsViewController release];
}

@end
