//
//  MemoryTrainingAppDelegate.h
//  MemoryTraining
//
//  Created by Jiayao Yu on 3/27/10.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import <UIKit/UIKit.h>

@class MainViewController;

@protocol CoreDataHelper
- (NSManagedObjectModel *)managedObjectModel;
- (NSManagedObjectContext *)managedObjectContext;
- (NSPersistentStoreCoordinator *)persistentStoreCoordinator;
- (NSFetchedResultsController *)fetchedResultsController;
@end


@interface MemoryTrainingAppDelegate : NSObject <UIApplicationDelegate, CoreDataHelper, NSFetchedResultsControllerDelegate> {
    UIWindow *window;
    MainViewController *viewController;
  
  NSManagedObjectModel *managedObjectModel;
  NSManagedObjectContext *managedObjectContext;	    
  NSPersistentStoreCoordinator *persistentStoreCoordinator;
  NSFetchedResultsController *fetchedResultsController;
}
//-(NSFetchedResultsController *)fetchedResultsController;
@property (nonatomic, retain, readonly) NSManagedObjectModel *managedObjectModel;
@property (nonatomic, retain, readonly) NSManagedObjectContext *managedObjectContext;
@property (nonatomic, retain, readonly) NSPersistentStoreCoordinator *persistentStoreCoordinator;
@property (nonatomic, retain, readonly) NSFetchedResultsController *fetchedResultsController;


@property (nonatomic, retain) IBOutlet UIWindow *window;
@property (nonatomic, retain) IBOutlet MainViewController *viewController;
- (NSString *)applicationDocumentsDirectory;
@end

